#! /usr/bin/perl
#* ============================================================
# * File        : archiveorg/formatlist.pl
# * Release     : 1
# * Author      : Eric
# * Date        : 2007-12-07
# * Description : returns single video url (handler for vidlist)
# * ============================================================ */



use English;
use XML::DOM;
use HTML::Entities;

#------------------------------------------------------------------------------
# Init
#------------------------------------------------------------------------------

&read_parse();    # get commandline parameters into @in
$source = $in[0]; # source filename from command line
$selected_title = $in[2];

my $doc = XML::DOM::Document->new;
my $head = $doc->createXMLDecl ('1.0');
my $root = $doc->createElement('items');

sub newNode
{
  local $name  = shift;
  local $value = shift;
  local $node = $doc->createElement($name);
  local $text = $doc->createTextNode($value);
  $node->appendChild($text);
  
  return $node;
}

#------------------------------------------------------------------------------
# read file into $data
#------------------------------------------------------------------------------

$datafile = $source;
open( INFO, "<$datafile" );      # Open file for reading
undef $/;
$data = <INFO>;                 # Read all
close(INFO);

#------------------------------------------------------------------------------
# Parse playlist
#------------------------------------------------------------------------------

              
##   <div id="sidebar">....
##   <a href="http://www.archive.org/stream/VJ_Mission_Human_Orchestra/VJ_Mission_Human_Orchestra_64kb.mp4">64Kb MPEG4</a>
##   ...
##   </div>

sub dump_lines
{
  # get rid of newlines
  $data =~ s/\n/ /g;
  # multiple spaces
  $data =~ s/\s\s+/ /g;
  # format station links

  if ($data =~ m/<div\sid="sidebar">(.*?)Download(.*)<\/div>/g)
  {
      $data1 = $1;
      $data2 = $2;
     
      while ($data1 =~ m/<a\shref="(http[^"]+\.[^"]{2,6})">(.*?)<\/a>(?:\s\(([^\)]+)\))?/gi)
      {     
         $item = $doc->createElement('item');
         $root->appendChild($item);

         $name = $selected_title . " $2";
         $url = $1;
         $handler = "";
         $size = $3;

         $name .= " (stream)";
         $handler = "";
         
         $item->appendChild( newNode('name', "$name") );
         $item->appendChild( newNode('url', $url) );
         $item->appendChild( newNode('descr', "$name") );
         $item->appendChild( newNode('handler', "$handler") );
      }
      
      while ($data2 =~ m/<a\shref="(http[^"]+\.[^"]{2,6})">(.*?)<\/a>(?:\s\(([^\)]+)\))?/gi)
      {     
         $item = $doc->createElement('item');
         $root->appendChild($item);

         $name = $selected_title . " $2";
         $url = $1;
         $handler = "FUZZY_DL";
         $size = $3;

         $name .= " ($size)";
         
         $item->appendChild( newNode('name', "$name") );
         $item->appendChild( newNode('url', $url) );
         $item->appendChild( newNode('descr', "$name") );
         $item->appendChild( newNode('handler', "$handler") );
      }

  }
  
  
}

#------------------------------------------------------------------------------
# search url's in $data and place them in special format
#------------------------------------------------------------------------------

&dump_lines();

print $head->toString;
print $root->toString;
print "\n";

#--------------------------------------------------------------------------------
# get command line parameters
#--------------------------------------------------------------------------------

sub read_parse 
{
  local (*in) = @_ if @_;
  local ($i);
  push(@in, @ARGV);
  foreach $i (0 .. $#in) { $in[$i] =~ s/\+/ /g;}
  return scalar(@in);
}



