#! /usr/bin/perl
#* ============================================================
# * File        : retrovision/videoplay.pl
# * Author      : Eric
# * Date        : 2007-12-07
# * Description : returns single video url (handler for vidlist)
# * ============================================================ */



use English;
use XML::DOM;
use HTML::Entities;

#------------------------------------------------------------------------------
# Init
#------------------------------------------------------------------------------

&read_parse();    # get commandline parameters into @in
$source = $in[0]; # source filename from command line

my $doc = XML::DOM::Document->new;
my $head = $doc->createXMLDecl ('1.0');
my $root = $doc->createElement('items');

sub newNode
{
  local $name  = shift;
  local $value = shift;
  local $node = $doc->createElement($name);
  local $text = $doc->createTextNode($value);
  $node->appendChild($text);
  
  return $node;
}

#------------------------------------------------------------------------------
# read file into $data
#------------------------------------------------------------------------------

$datafile = $source;
open( INFO, "<$datafile" );      # Open file for reading
undef $/;
$data = <INFO>;                 # Read all
close(INFO);

#------------------------------------------------------------------------------
# Parse playlist
#------------------------------------------------------------------------------

              
## <tr class="hitRow"><td class="numberCell"><img src="/images/mediatype_movies.gif"/></td><td class="hitCell">
## <a  class="titleLink" href="/details/Rashomon">Rashomon</a> - Minoru Jingo, Masaichi Nagata<br/>A rape and murder
## in medieval Japan are recounted in four flashback sequences, as seen through the eyes of the three people involved
## and a witness to the incident. Each version differs from the others, leaving viewers to draw their own conclusions
## on what actually transpired. Akira Kurosawa's breakthrough drama stars Toshiro Mifune, Machiko Kyo.<br/>

## matches of search term are highlighted by <span class="searchTerm">matching text</span>text

## links to Next, Prev, First, Last pages:  <a href="/search.php?query=%28collection%3Afeature_films%20OR%20mediatype%3Afeature_films%29%20AND%20-mediatype%3Acollection&sort=-%2Freviews%2Finfo%2Favg_rating%3B-%2Freviews%2Finfo%2Fnum_reviews&page=2">Next</a>

sub dump_lines
{
  # get rid of newlines
  $data =~ s/\n/ /g;
  # multiple spaces
  $data =~ s/\s\s+/ /g;
  # format station links
  
  if ($data =~  /<a\shref="([^"]+)">First<\/a>/ )
  {
         $item = $doc->createElement('item');
         $root->appendChild($item);
         
         $item->appendChild( newNode('name', "[Goto first page]") );
         $item->appendChild( newNode('url', $1) );
         $item->appendChild( newNode('descr', "") );
         $item->appendChild( newNode('handler', "archiveorg/searchlist") );
  }
  
  if ($data =~  /<a\shref="([^"]+)">Prev<\/a>/ )
  {
         $item = $doc->createElement('item');
         $root->appendChild($item);
         
         $item->appendChild( newNode('name', "[Goto previous page]") );
         $item->appendChild( newNode('url', $1) );
         $item->appendChild( newNode('descr', "") );
         $item->appendChild( newNode('handler', "archiveorg/searchlist") );
  }
  
  while ( $data =~ m/<a\sclass="titleLink"\shref="([^"]+)">(.+?)<\/a>([^<]*)<br\/>(.*?(?=<br)).*?<\/tr>/g )
  {
         $item = $doc->createElement('item');
         $root->appendChild($item);
            
         $title = $2 . $3;
         $url = $1;
         $descr = $4;

         $title =~ s/<span class="[^"]+">([^<]+)<\/span>/\1/g;
         $descr =~ s/<span class="[^"]+">([^<]+)<\/span>/\1/g;
         
         $item->appendChild( newNode('name', "$title") );
         $item->appendChild( newNode('url', $url) );
         $item->appendChild( newNode('descr', "$descr") );
         $item->appendChild( newNode('handler', "archiveorg/formatlist") );
  }

  if ($data =~  /<a\shref="([^"]+)">Next<\/a>/ )
  {
         $item = $doc->createElement('item');
         $root->appendChild($item);
         
         $item->appendChild( newNode('name', "[Goto next page]") );
         $item->appendChild( newNode('url', $1) );
         $item->appendChild( newNode('descr', "") );
         $item->appendChild( newNode('handler', "archiveorg/searchlist") );
  }
  
  if ($data =~ /<a\shref="([^"]+)">Last<\/a>/ )
  {

         $item = $doc->createElement('item');
         $root->appendChild($item);
         
         $item->appendChild( newNode('name', "[Goto last page]") );
         $item->appendChild( newNode('url', $1) );
         $item->appendChild( newNode('descr', "") );
         $item->appendChild( newNode('handler', "archiveorg/searchlist") );
  }

}
  
  
#------------------------------------------------------------------------------
# search url's in $data and place them in special format
#------------------------------------------------------------------------------

&dump_lines();

print $head->toString;
print $root->toString;
print "\n";

#--------------------------------------------------------------------------------
# get command line parameters
#--------------------------------------------------------------------------------

sub read_parse 
{
  local (*in) = @_ if @_;
  local ($i);
  push(@in, @ARGV);
  foreach $i (0 .. $#in) { $in[$i] =~ s/\+/ /g;}
  return scalar(@in);
}



