#! /usr/bin/perl
#* ============================================================
# * File  : pserver_init.pl
# * Author: Eric Giesselbach <ericgies@kabelfoon.nl>
# * Date  : 2007-09-30
# * Description : MythStream Player Service parser example
# *               Starts stream with pserv_example player service
# * ============================================================ */
# *
# * This parser sets the stream item pserv field to pserver
# * MythStream calls that parser when the stream item reaches state "playing"
# * Parser pserver takes control of MythStream textarea and image fields
# *
# * See pserver.pl for more info
# *

use English;
use XML::Simple;
use XML::DOM;

$xml = new XML::Simple;

my $doc = XML::DOM::Document->new;
my $head = $doc->createXMLDecl ('1.0');
my $root = $doc->createElement('screen');

sub newNode
{
  local $name  = shift;
  local $value = shift;
  local $node = $doc->createElement($name);
  local $text = $doc->createTextNode($value);
  $node->appendChild($text);
  
  return $node;
}

$item = $doc->createElement('item');
$root->appendChild($item);
$item->appendChild( newNode('name' , "example of stream with player service") );
$item->appendChild( newNode('url'  , "http://broadcast.infomaniak.ch/energyblack-high.mp3.m3u") );
$item->appendChild( newNode('pserv'  , "examples/pserver") );
print $head->toString;
print $root->toString;
print "\n";

#------------------------------------------------------------------------------
# Init and Run
#------------------------------------------------------------------------------


