#! /usr/bin/perl
#* ============================================================
# * File        : retrovision/catlist.pl
# * Author      : Eric
# * Date        : 2007-12-07
# * Description : parses mainpage categories
# * ============================================================ */

use English;
use XML::DOM;
use HTML::Entities;

#------------------------------------------------------------------------------
# Init
#------------------------------------------------------------------------------

&read_parse();    # get commandline parameters into @in
$source = $in[0]; # source filename from command line

my $doc = XML::DOM::Document->new;
my $head = $doc->createXMLDecl ('1.0');
my $root = $doc->createElement('items');

sub newNode
{
  local $name  = shift;
  local $value = shift;
  local $node = $doc->createElement($name);
  local $text = $doc->createTextNode($value);
  $node->appendChild($text);
  
  return $node;
}

#------------------------------------------------------------------------------
# read file into $data
#------------------------------------------------------------------------------

$datafile = $source;
open( INFO, "<$datafile" );      # Open file for reading
undef $/;
$data = <INFO>;                 # Read all
close(INFO);

#------------------------------------------------------------------------------
# Parse playlist
#------------------------------------------------------------------------------

# parser film.pl finds line in http://freedocumentaries.org/film.php?id=171:
# <a href="javascript: void launchFilm('1033');void window.open('pop.php', '', 'width=350, height=180');" class="right"><span class="style5-watch">Watch Film Now!</span></a>

# substitue [number] with 1033 from previous page results in url:
# http://freedocumentaries.org/theatre.php?id=[number]
# that page should be handed to vid.pl

sub dump_lines
{
  # get rid of newlines
  $data =~ s/\n/ /g;
  # multiple spaces
  $data =~ s/\s\s+/ /g;
  # format station links
  $data = decode_entities($data);

  if ($data =~ m/<a\shref=".*?launchFilm\('(\d+)'\).*?Watch\sFilm\sNow/i)
  {
     $name = $1;
     $url = "http://freedocumentaries.org/theatre.php?id=$1";
     #$name =~ s/\%([A-Fa-f0-9]{2})/pack('C', hex($1))/seg;

     $item = $doc->createElement('item');
     $root->appendChild($item);
     $item->appendChild( newNode('name', "$name") );
     $item->appendChild( newNode('url', $url) );
     $item->appendChild( newNode('descr', "") );
     $item->appendChild( newNode('handler', "freedocumentaries/vid") );
}
  
}

#------------------------------------------------------------------------------
# search url's in $data and place them in special format
#------------------------------------------------------------------------------

&dump_lines();

binmode STDOUT, ":utf8";

print $head->toString;
print $root->toString;
print "\n";

#--------------------------------------------------------------------------------
# get command line parameters
#--------------------------------------------------------------------------------

sub read_parse 
{
  local (*in) = @_ if @_;
  local ($i);
  push(@in, @ARGV);
  foreach $i (0 .. $#in) { $in[$i] =~ s/\+/ /g;}
  return scalar(@in);
}



