#! /usr/bin/perl
#* ============================================================
# * File        : retrovision/vidlist.pl
# * Author      : Eric
# * Date        : 2007-12-07
# * Description : parses videolist in category (handler for catlist items)
# * ============================================================ */


use English;
use XML::DOM;
use HTML::Entities;

#------------------------------------------------------------------------------
# Init
#------------------------------------------------------------------------------

&read_parse();    # get commandline parameters into @in
$source = $in[0]; # source filename from command line

my $doc = XML::DOM::Document->new;
my $head = $doc->createXMLDecl ('1.0');
my $root = $doc->createElement('items');

sub newNode
{
  local $name  = shift;
  local $value = shift;
  local $node = $doc->createElement($name);
  local $text = $doc->createTextNode($value);
  $node->appendChild($text);
  
  return $node;
}

#------------------------------------------------------------------------------
# read file into $data
#------------------------------------------------------------------------------

$datafile = $source;
open( INFO, "<$datafile" );      # Open file for reading
undef $/;
$data = <INFO>;                 # Read all
close(INFO);

#------------------------------------------------------------------------------
# Parse playlist
#------------------------------------------------------------------------------

              
##<a href="http://retrovision.tv/?p=490" rel="bookmark" title="Permalink of Africa Screams (1949)">

sub dump_lines
{
  # get rid of newlines
  $data =~ s/\n/ /g;
  # multiple spaces
  $data =~ s/\s\s+/ /g;
  # format station links
  $data = decode_entities($data);
  
  while ($data =~ m/<a[^>]+href="(http:\/\/retrovision.tv\/\?p=[^"]+)"[^>]+?rel="bookmark"[^>]+?title="Permalink\sof\s(.+?)">(?:.*?<\/div>.*?<p>(.*?)<\/p>)?/gi)
  {
     $item = $doc->createElement('item');
     $root->appendChild($item);
        
     $item->appendChild( newNode('name', "$2") );
     $item->appendChild( newNode('url', $1) );
     $item->appendChild( newNode('descr', "select video: $2") );
     $item->appendChild( newNode('handler', "retrovision/videoplay") );
   
     $meta = $doc->createElement('meta');
     $meta->appendChild( newNode('name'   , "description") );
     $meta->appendChild( newNode('content', $3) );
     $meta->appendChild( newNode('viewer' , "text") );
     $item->appendChild( $meta );
  }
  
}

#------------------------------------------------------------------------------
# search url's in $data and place them in special format
#------------------------------------------------------------------------------

&dump_lines();

print $head->toString;
print $root->toString;
print "\n";

#--------------------------------------------------------------------------------
# get command line parameters
#--------------------------------------------------------------------------------

sub read_parse 
{
  local (*in) = @_ if @_;
  local ($i);
  push(@in, @ARGV);
  foreach $i (0 .. $#in) { $in[$i] =~ s/\+/ /g;}
  return scalar(@in);
}



