#! /usr/bin/perl
#* ============================================================
# * File        : retrovision/xmllist.pl
# * Author      : Eric
# * Date        : 2007-12-07
# * Description : decodes flasplayer playlist
# * ============================================================ */

use English;
use XML::Simple;
use XML::DOM;
use Data::Dumper;


$xml = new XML::Simple;

my $doc = XML::DOM::Document->new;
my $head = $doc->createXMLDecl ('1.0');
my $root = $doc->createElement('items');

sub newNode
{
  local $name  = shift;
  local $value = shift;
  local $node = $doc->createElement($name);
  local $text = $doc->createTextNode($value);
  $node->appendChild($text);
  
  return $node;
}

sub checkNode
{
   local $node = shift;   
   return ( $node && !($node =~ /^HASH/) )  # deref empty hash element
}

sub parseItem
{
  local $entry = shift;
  
  $item = $doc->createElement('item');
  $item->appendChild( newNode('name'   , $entry->{title}) );
  $item->appendChild( newNode('url'    , $entry->{location}) );
  $item->appendChild( newNode('descr'  , "") );
  $root->appendChild($item);
}

#------------------------------------------------------------------------------
# Init and Run
#------------------------------------------------------------------------------

&read_parse();    # get commandline parameters into @in
$source = $in[0]; # source filename from command line

eval{ $data = $xml->XMLin($source); };


$channel = $data->{trackList};

if ( ref($channel->{track}) eq 'ARRAY' )
{
  foreach my $entry (@{$channel->{track}}) { parseItem($entry); }
}
  else
{
  parseItem($channel->{track});
}

print $head->toString;
print $root->toString;
print "\n";

#--------------------------------------------------------------------------------
# get command line parameters
#--------------------------------------------------------------------------------

sub read_parse {
  local (*in) = @_ if @_;
  local ($i);
  push(@in, @ARGV);
  foreach $i (0 .. $#in) { $in[$i] =~ s/\+/ /g;}
  return scalar(@in);
}


