#! /usr/bin/perl
#* ============================================================
# * File        : youtube/youvid.pl
# * Version     : 5 
# * Author      : 
# * Date        : 2008-08-30
# * Description: parser for youtube feed
# *
# * Requires:
# * - mythstream v0.17_2 http 30x (and cookie?) handling
# *
# * ============================================================ */

use English;
use XML::DOM;
use HTML::Entities;

#------------------------------------------------------------------------------
# Init
#------------------------------------------------------------------------------

&read_parse();    # get commandline parameters into @in
$source = $in[0]; # source filename from command line
$sname = $in[2];

# remove quotes from sname
$sname =~ s/^\"?(.*?)\"?$/$1/;

my $doc = XML::DOM::Document->new;
my $head = $doc->createXMLDecl ('1.0');
my $root = $doc->createElement('items');

sub newNode
{
  local $name  = shift;
  local $value = shift;
  local $node = $doc->createElement($name);
  local $text = $doc->createTextNode($value);
  $node->appendChild($text);
  
  return $node;
}

#------------------------------------------------------------------------------
# read file into $data
#------------------------------------------------------------------------------

$datafile = $source;
open( INFO, "<$datafile" );      # Open file for reading
undef $/;
$data = <INFO>;                 # Read all
close(INFO);

#------------------------------------------------------------------------------
# Parse playlist
#------------------------------------------------------------------------------




# &dump_lines();

# OLD: BASE_YT_URL:'http://youtube.com/',video_id:'iYWrMWH6rGA',l:'83',t:'OEgsToPDskL33Dsy3NGyvOx2YJG_MEtK',sk:
# NEW: see search.pl

my $a, $b;

if ( ($a, $b) = $data =~ /'SWF_ARGS'\s*\:\s*\{.*?"t":\s*"([^"]+)".+?"video_id":\s*"([^"]+)"/ )
{
      $url = "http://www.youtube.com/get_video?video_id=$b&t=$a";

      my $fmt_h264 = ($data =~ /'SWF_URL'\s*:\s*.*\.flash\.canPlayH264Videos()/);

      $item = $doc->createElement('item');
      $root->appendChild($item);
      
      $item->appendChild( newNode('name', "play: $sname") );
      $item->appendChild( newNode('url',  $url) );
      $item->appendChild( newNode('descr', "") );
      $item->appendChild( newNode('handler', "") );

      if ($fmt_h264)
      {
         $item = $doc->createElement('item');
         $root->appendChild($item);
         
         $item->appendChild( newNode('name', "play: $sname [H.264]") );
         $item->appendChild( newNode('url',  $url . '&fmt=18') );
         $item->appendChild( newNode('descr', "") );
         $item->appendChild( newNode('handler', "") );
      }

      $item = $doc->createElement('item');
      $root->appendChild($item);
      
      $item->appendChild( newNode('name', "download: $sname") );
      $item->appendChild( newNode('url',  $url) );
      $item->appendChild( newNode('descr', "") );
      $item->appendChild( newNode('handler', "STREAM_DL") );

      if ($fmt_h264)
      {
         $item = $doc->createElement('item');
         $root->appendChild($item);
         
         $item->appendChild( newNode('name', "download: $sname [H.264]") );
         $item->appendChild( newNode('url',  $url . '&fmt=18') );
         $item->appendChild( newNode('descr', "") );
         $item->appendChild( newNode('handler', "STREAM_DL") );
      }
}

print $head->toString;
print $root->toString;
print "\n";

#--------------------------------------------------------------------------------
# get command line parameters
#--------------------------------------------------------------------------------

sub read_parse 
{
  local (*in) = @_ if @_;
  local ($i);
  push(@in, @ARGV);
  foreach $i (0 .. $#in) { $in[$i] =~ s/\+/ /g;}
  return scalar(@in);
}



